/*
 * emailhub.c	by SASANO Takayoshi
 *
 * public domain.
 * եȥȯԤֳȯפʤƸƤǤ褦ʿͤ
 * ΥץȤäߤʤʡȻפ
 */

#include	<basic.h>
#include	<bstdio.h>
#include	<bstdlib.h>
#include	<tcode.h>
#include	<inner.h>
#include	<errcode.h>
#include	<driver/driver.h>
#include	<driver/usb.h>

#define	DEFAULTPRI	80
#define	STACKSIZE	2048

#ifdef	DEBUG
#define	DP(x)	printf x
#else
#define	DP(x)	/* */
#endif

LOCAL	ID	Porid;
LOCAL	W	DeviceAddr = -1;


/*
 * is_device(): ǥХ¸߳ǧ
 */
LOCAL	W	is_device(W adr)
{
    W	err;
    usbDeviceDescriptor	d;

    err = usbDescriptorDevice(adr, (UB *)&d, sizeof(d), NULL);

    return (err >= 0 && d.idVendor == 0x04b4 && d.idProduct == 0xfef4);
}


/*
 * find_device(): ǥХ
 */
LOCAL	WERR	find_device(VOID)
{
    W	i;

    for(i = 0; i < 128; i++) if(is_device(i)) return i;

    return ER_NODEV;
}


/*
 * send_command(): ǥLED
 */
LOCAL	VOID	send_command(W adr, W par)
{
    usbDeviceRequest	r;

    r.bmRequestType = 0x80;
    r.bRequest      = USB_GET_DESCRIPTOR;
    r.wIndex        = 0x0409;

    /*  */
    r.wValue        = 0x333;
    usbRequestDevice(adr, &r, NULL, 0, NULL);

    /* LED */
    if(par & 1) {
	r.wValue    = 0x31f;
	usbRequestDevice(adr, &r, NULL, 0, NULL);
    }

    /* 르 */
    if(par & 2) {
	r.wValue    = 0x329;
	usbRequestDevice(adr, &r, NULL, 0, NULL);
    }

    return;
}


/*
 * read_write_request(): ɤ߽׵Ф
 */
LOCAL	ERR	read_write_request(DevReq *q, DevRsp *r)
{
    ERR	err = ER_NODEV;

    /* DC_USBEVENTȤΤڤʤɤ͡ */
    if(!is_device(DeviceAddr)) {
	DeviceAddr = find_device();

	if(DeviceAddr < 0) goto fin;
    }

    send_command(DeviceAddr, q->datano);
    err = ER_OK;

 fin:
    if(err < 0) DP(("read_write_request(): %d\n", err));
    return err;
}


/*
 * io_request(): ɥ饤׵
 */
LOCAL	ERR	io_request(DevReq *q, DevRsp *r)
{
    ERR	err;

    switch(q->cmd.cmd) {
    case	DC_READ:
    case	DC_WRITE:
	err = read_write_request(q, r);	/*  */
	break;

    case	DC_OPEN:
    case	DC_CLOSE:
    case	DC_CLOSEALL:

    case	DC_ABORT:
    case	DC_SUSPEND:
    case	DC_RESUME:
    case	DC_CARDEVENT:
	err = ER_OK;
	break;

    default:
	err = ER_NOSPT;
	break;
    }

    return(err);
}


/*
 * io_maintask(): ᥤ󥿥
 */
LOCAL	VOID	io_maintask(ID porid)
{
    ERR	err;
    RNO	rdvno;
    W	size;
    DevReq	q;
    DevRsp	r;

    while(1) {
	/* ׵Ԥ */
	err = acp_por(&rdvno, (VP)&q, &size, porid, D_ABORT_PTN | D_NORM_PTN);
	if(err < 0) goto fin;

	/* ΰۤʤѥåȤ̵ */
	if(size != sizeof(DevReq)) {
	    DP(("io_maintask(): bad packet size (%d)\n", size));
	    continue;
	}

	/* ѥѥåȤν׵μ¹ */
	r.devid     = q.devid;
	r.cmd       = q.cmd;
	r.datano    = q.datano;
	r.datacnt   = 0;
	r.error.err = io_request(&q, &r);

	/* ǥ֤ؤ */
	err = rpl_rdv(rdvno, (VP)&r, sizeof(DevRsp));
	if(err < 0) DP(("io_maintask(): rpl_por() failed(%d)\n", err));
    }

    /* ϿǥХ̾äʤȤʤΤ */
 fin:
    del_por(porid);
    exd_tsk();
}


/*
 * main(): ɥ饤Сȥݥ
 */
EXPORT	ERR	main(Bool start, TC *arg)
{
    T_CPOR	cpor;
    T_CTSK	ctsk;
    ERR	err;
    ID	tskid;

    DevDef	devdef = {
	{0}, 0, {L""}, 0,
    };

    /* λ׵ */
    if(!start) {
	err = del_por(Porid);
	goto fin0;
    }

    /* ǥ֥ݡȺ */
    cpor.exinf   = NULL;
    cpor.poratr  = TA_NULL;
    cpor.maxcmsz = sizeof(DevReq);
    cpor.maxrmsz = sizeof(DevRsp);

    err = vcre_por(&cpor);
    if(err < 0) {
	DP(("main(): vcre_por(): %d\n", err));
	goto fin0;
    }
    Porid = (ID) err;

    /* դ */
    ctsk.exinf   = NULL;
    ctsk.task    = io_maintask;
    ctsk.itskpri = DEFAULTPRI;
    ctsk.stksz   = STACKSIZE;
    ctsk.tskatr  = TA_HLNG | TA_RNG0;

    err = vcre_tsk(&ctsk);
    if(err < 0) {
	DP(("main(): vcre_tsk(): %d\n", err));
	goto fin1;
    }
    tskid = (ID) err;

    /* ǥХ°ꤪϿ */
    devdef.attr.devinfo  = 0;		/* äꤷʤ */
    devdef.attr.devkind  = DK_UNDEF;	/* ̤ */
    devdef.attr.reserved = 0;		/* ͽ(0) */
    devdef.attr.openreq  = 1;		/* open/close׵ͭ */
    devdef.attr.lockreq  = 0;		/* lock */
    devdef.attr.diskinfo = 0;		/* DN_DISKINO̤б */
    devdef.attr.chardev  = 1;		/* ʸǥХ */
    devdef.attr.nowait   = 0;		/* nowait⡼б */
    devdef.attr.eject    = 0;		/* eject */

    devdef.portid        = Porid;	/* ǥ֥ݡID */

    err = DefDevice(&devdef, NULL);
    if(err < 0) {
	DP(("main(): DefDevice(): %d\n", err));
	goto fin2;
    }

    /* դư */
    err = sta_tsk(tskid, Porid);
    if(err < 0) {
	DP(("main(): sta_tsk(): %d\n", err));
	goto fin3;
    }

    err = ER_OK;
    goto fin0;

    /*  */
/* fin4: */
    ter_tsk(tskid);
 fin3:
    devdef.portid = 0;
    DefDevice(&devdef, NULL);
 fin2:
    del_tsk(tskid);
 fin1:
    del_por(Porid);
 fin0:
    return err;
}
